/*---------------------------------------------------------------------------*/
/* GIVE-PRV.C -- contains routines to modify privilege levels according to   */
/* the operations being performed.                                           */

#include <starlet.h>
#include <ssdef.h>
#include <prvdef.h>
#include "give.h"
#include "give-prv.h"

/*---------------------------------------------------------------------------*/
/* Priv_Enable -- this function enables one or more privileges               */

void Priv_Enable( ulong priv_mask )
{
   ulong ss_stat;

   ss_stat = sys$setprv( 1, &priv_mask, 0, 0 );
   if( ss_failure( ss_stat ) )   
      exit( ss_stat );

}

/*---------------------------------------------------------------------------*/
/* Priv_Disable -- this function disables one or more privileges             */

void Priv_Disable( ulong priv_mask )
{
   ulong ss_stat;

   ss_stat = sys$setprv( 0, &priv_mask, 0, 0 );
   if( ss_failure( ss_stat ) )
      exit( ss_stat );

}

