/*---------------------------------------------------------------------------*/
/* GIVE.H -- main header file for GIVE.C and associated source files.        */
/*---------------------------------------------------------------------------*/

#include <descrip.h>
#include <stdlib.h>

/*------*/
/* Type definitions                                                          */

typedef unsigned char uchar;
typedef unsigned short int ushort;
typedef unsigned long int ulong;
typedef char schar;
typedef short int sshort;
typedef long int slong;
typedef int boolean;

struct auth_entry {
   struct dsc$descriptor_s username;
   struct dsc$descriptor_s identifier;
   struct dsc$descriptor_s account;
   ulong max_size;
   ulong flags;
   struct auth_entry *next;
};

/*------*/
/* Macro declarations                                                        */

#define ss_failure( exp ) (!(exp & 1))
#define ss_success( exp ) (exp & 1)
#define $DESCRIPTOR_L( name, string, length ) struct dsc$descriptor_s name = \
        { length, DSC$K_DTYPE_T, DSC$K_CLASS_S, string }
#define $DESCRIPTOR_Z( name, string ) struct dsc$descriptor_s name = \
        { strlen( string ), DSC$K_DTYPE_T, DSC$K_CLASS_S, string }
#define null_terminate( string, length ) (string)[length]='\0'

/*------*/
/* Constant declarations                                                     */

#define FALSE 0
#define TRUE (!FALSE)

#ifndef NULL
#define NULL ((void *)0)
#endif

#define K_USERNAME_LEN 12
#define K_FILENAME_LEN 255
#define K_DEVICE_LEN 31
#define K_ACCOUNT_LEN 8
#define K_TIMESTR_LEN 23
#define K_RESOURCE_LEN 31

#define K_DESTDIR_POSTFIX ".GIVEN_FILES]"
#define K_AUTH_FILENAME "GIVE.AUTH$USERS"
#define K_SAMPLE_AUTH_FILENAME "SAMPLE_GIVE_AUTH_FILE"
#define K_LOG_FILENAME "GIVE.LOG"
#define K_AUTHLINE_LEN 255
#define K_AUTH_COMMENT_CHAR '!'
#define K_AUTH_TOKEN_SEPARATORS " \n\t"
#define K_AUTH_TOKEN_PREFIX "PREFIX"
#define K_AUTH_TOKEN_POSTFIX "POSTFIX"
#define K_AUTH_TOKEN_SUBDIR "SUBDIR"
#define K_AUTH_TOKEN_NONE "NONE"

#define K_INCOMING_HEADER 0
#define K_INCOMING_PREFIX 55
#define K_INCOMING_POSTFIX 56
#define K_INCOMING_SUBDIR 57
#define K_INCOMING_NONE 58

#define K_MAX_FILENAMES 256
#define K_MAX_USERNAMES 256

#define K_BELL 7

/*------*/
/* Globals                                                                   */

extern boolean qual_debug;
extern boolean qual_log;

#include "give-msg.h"

